package com.xiaoniu.subsystem.business.service.impl;

import com.alibaba.nacos.common.utils.CollectionUtils;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.xiaoniu.common.core.exception.ServiceException;
import com.xiaoniu.common.core.utils.StringUtils;
import com.xiaoniu.common.core.utils.bean.BeanValidators;
import com.xiaoniu.subsystem.business.domain.ExamQuestion;
import com.xiaoniu.subsystem.business.domain.Flight;
import com.xiaoniu.subsystem.business.domain.PersonnelConfirm;
import com.xiaoniu.subsystem.business.mapper.PersonnelConfirmMapper;
import com.xiaoniu.subsystem.business.service.IFlightService;
import com.xiaoniu.subsystem.business.service.IPersonnelConfirmService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.xiaoniu.subsystem.system.domain.Unit;
import com.xiaoniu.subsystem.system.service.IUnitService;
import jakarta.validation.Validator;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import static com.xiaoniu.common.security.utils.SecurityUtils.getUnitId;
import static com.xiaoniu.common.security.utils.SecurityUtils.getUserId;

/**
 * <p>
 * 信息确认表 服务实现类
 * </p>
 *
 * @author haoxuyang
 * @since 2024-12-23 05:36:11
 */
@Service
public class PersonnelConfirmServiceImpl extends ServiceImpl<PersonnelConfirmMapper, PersonnelConfirm> implements IPersonnelConfirmService {
    protected final IUnitService unitService;
    protected final Validator validator;
    protected final IFlightService flightService;

    public PersonnelConfirmServiceImpl(IUnitService unitService, Validator validator, IFlightService flightService) {
        this.unitService = unitService;
        this.validator = validator;
        this.flightService = flightService;
    }

    @Override
    public String importData(List<PersonnelConfirm> list, boolean isUpdateSupport) {
        if (CollectionUtils.isEmpty(list)) {
            throw new ServiceException("导入人员信息确认数据不能为空！");
        }
        int successNum = 0;
        int failureNum = 0;
        Map<String, Long> map = new HashMap<String, Long>();
        Map<String, Long> map1 = new HashMap<String, Long>();
        StringBuilder successMsg = new StringBuilder();
        StringBuilder failureMsg = new StringBuilder();
        Unit unit = unitService.getById(getUnitId());
        List<Unit> unitList = unitService.list();
        List<Unit> units =
                unitList.stream().filter(u -> StringUtils.equals("0", u.getType())).collect(Collectors.toList());
        if (CollectionUtils.isNotEmpty(units)) {
            map.putAll(units.stream().collect(Collectors.toMap(Unit::getUnitName, Unit::getUnitId)));
        }
        List<Unit> units1 =
                unitList.stream().filter(u -> StringUtils.equals("1", u.getType())).collect(Collectors.toList());
        if (CollectionUtils.isNotEmpty(units1)) {
            map1.putAll(units1.stream().collect(Collectors.toMap(Unit::getUnitName, Unit::getUnitId)));
        }
        for (PersonnelConfirm d : list) {
            try {
                //查询班次是否存在
                Flight flight = flightService.getOne(new LambdaQueryWrapper<Flight>()
                        .eq(Flight::getFlightName,d.getFlightName())
                        .eq(Flight::getYear,d.getYear())
                        .eq(Flight::getTrainingTime,d.getTrainingTime())
                );
                if (flight != null){
                    d.setFlightId(flight.getFlightId());
                }
                //根据送训单位名称查询送训单位信息
                Unit unit1 = unitService.getUnitByName(d.getSendingUnitName());
                if (unit1 != null){
                    d.setSendingUnitId(unit1.getUnitId());
                }
                // 验证是否存在这个数据
                PersonnelConfirm u = baseMapper.selectOne(new LambdaQueryWrapper<PersonnelConfirm>()
                        .eq(PersonnelConfirm::getUserName, d.getUserName())
                        .eq(PersonnelConfirm::getFlightName, d.getFlightName())
                        .eq(PersonnelConfirm::getTrainingTime,d.getTrainingTime())
                        .eq(PersonnelConfirm::getYear,d.getYear())
                        .eq(PersonnelConfirm::getIdCard, d.getIdCard()));
                if (StringUtils.isNull(u)) {
                    BeanValidators.validateWithException(validator, d);
                    d.setCreateUser(getUserId());
                    d.setCreateDept(unit.getUnitId());
                    d.setCreateTime(new Date());
                    this.save(d);
                    successNum++;
                    successMsg.append("<br/>" + successNum +"、" + " 人员 " + d.getUserName() +  "导入成功");
                } else if (isUpdateSupport) {
                    BeanValidators.validateWithException(validator, d);
                    d.setUpdateUser(getUserId());
                    d.setUpdateTime(new Date());
                    d.setPersonId(u.getPersonId());
                    this.updateById(d);
                    successNum++;
                    successMsg.append("<br/>" + successNum + "、" + " 人员 " + d.getUserName() +  "更新成功");
                } else {
                    failureNum++;
                    failureMsg.append("<br/>" + failureNum + "、" + " 人员 " + d.getUserName() + "已存在");
                }
            } catch (Exception e) {
                failureNum++;
                String msg = "<br/>" + failureNum +  " 导入失败：";
                failureMsg.append(msg + e.getMessage());
                log.error(msg, e);
            }
        }
        if (failureNum > 0) {
            failureMsg.insert(0, "很抱歉，导入失败！共 " + failureNum + " 条数据格式不正确，错误如下：");
            throw new ServiceException(failureMsg.toString());
        } else {
            successMsg.insert(0, "恭喜您，数据已全部导入成功！共 " + successNum + " 条，数据如下：");
        }
        return successMsg.toString();
    }
}
